#include<bits/stdc++.h>
using namespace std;
int n,q;
long long h[200050];
long long d[200050], p[200050];
unsigned long long prefsum[200050];
int mini, maks, sred;
bool pr;

int main ()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cin >> n >> q;
    for(int i=1; i<=n; i++)
    {
        cin >> d[i] >> p[i];
        prefsum[i] = prefsum[i-1] + d[i];
    }
    for(int i=1; i<=q; i++)
    {
        cin >> h[i];
        if(prefsum[n] < h[i])
            cout << "-1 \n";
        else
        {
            mini = 1;
            maks = n;
            while(mini <= maks)
            {
                sred = (mini+maks)/2;
                if(prefsum[sred] >= h[ind] and prefsum[sred-1] < h[ind])
                    cout << sred << "\n";
                if(prefsum[sred] >= h[ind])
                    maks = sred-1;
                if(prefsum[sred] < h[ind])
                    mini = sred+1;
            }
        }
    }
    return 0;
}
/*
3 5
3 0
4 0
5 0
3
4
5
13
2

*/